<!-- Improved compatibility of back to top link: See: https://github.com/othneildrew/Best-README-Template/pull/73 -->
<a name="readme-top"></a>
<!--
*** Thanks for checking out the Best-README-Template. If you have a suggestion
*** that would make this better, please fork the repo and create a pull request
*** or simply open an issue with the tag "enhancement".
*** Don't forget to give the project a star!
*** Thanks again! Now go create something AMAZING! :D
-->



<!-- PROJECT SHIELDS -->
<!--
*** I'm using markdown "reference style" links for readability.
*** Reference links are enclosed in brackets [ ] instead of parentheses ( ).
*** See the bottom of this document for the declaration of the reference variables
*** for contributors-url, forks-url, etc. This is an optional, concise syntax you may use.
*** https://www.markdownguide.org/basic-syntax/#reference-style-links
-->
[![GNU License][license-shield]][license-url]
[![Nim][Nim.com]][Nim-url]
[![LinkedIn][linkedin-shield]][linkedin-url]



<!-- PROJECT LOGO -->
<br />
<div align="center">
  <a href="https://git.bcmaison.cf/Projets/nim-lib">
    <img src="images/logo-nim.jpg" alt="Logo" width="250" height="100">
  </a>

  <h3 align="center">Nim Lib</h3>

  <p align="center">
    Personal Nim library  
    <br />
    <a href="https://git.bcmaison.cf/Projets/nim-lib"><strong>Explore the docs »</strong></a>
    <br />
    <br />
    <a href="#">View Demo</a>
    ·
    <a href="https://git.bcmaison.cf/Projets/nim-lib/issues">Report Bug</a>
    ·
    <a href="https://git.bcmaison.cf/Projets/nim-lib/pulls">Request Feature</a>
  </p>
</div>



<!-- TABLE OF CONTENTS -->
<details>
  <summary>Table of Contents</summary>
  <ol>
    <li>
      <a href="#about-the-project">About The Project</a>
      <ul>
        <li><a href="#built-with">Built With</a></li>
      </ul>
    </li>
    <li>
      <a href="#getting-started">Getting Started</a>
      <ul>
        <li><a href="#prerequisites">Prerequisites</a></li>
        <li><a href="#installation">Installation</a></li>
      </ul>
    </li>
    <li><a href="#usage">Usage</a></li>
    <li><a href="#base">Base</a></li>
    <li><a href="#usage">Usage</a></li>
    <li><a href="#usage">Usage</a></li>
    <li><a href="#usage">Usage</a></li>
    <li><a href="#usage">Usage</a></li>
    <li><a href="#roadmap">Roadmap</a></li>
    <li><a href="#contributing">Contributing</a></li>
    <li><a href="#license">License</a></li>
    <li><a href="#contact">Contact</a></li>
    <li><a href="#acknowledgments">Acknowledgments</a></li>
  </ol>
</details>

<!-- ABOUT THE PROJECT -->
## About The Project

[![Product Name Screen Shot][product-screenshot]](https://git.bcmaison.cf/Projets/nim-lib/src/branch/main/images/screenshot.png)

Cette librairie permet de centraliser tous les types de besoins génériques à une même place. Elle est découpé en plusieurs regroupement :


| Section              | script                  | description                                                                  |
| -------------------- | ----------------------- | ---------------------------------------------------------------------------- |
| 📂 base               | 📄 OutilsBase.nim        | Fonctions de base, petit traitement et opérations sur chaines, encryption.   |
| 📂 commun             | 📄 OutilsCommun.nim      | Traitement et fonctions communes sur heures, date, os, fichiers, répertoires |
| 📂 commun             | 📄 password_utils.nim    |                                                                              |
| 📂 commun             | 📄 utils.nim             |                                                                              |
| 📂 commun ➡️ load      | 📄                       | Fonctions de chargement des données de divers types (CSV, list, json, ...)   |
| 📂 commun ➡️ save      | 📄                       | Fonctions de sauvegarde des données de divers types (CSV, list, json, ...)   |
| 📂 Communication      | 📄                       | Fonctions de communications                                                  |
| 📂 Comm. ➡️ discord    | 📄                       | communication de type discord                                                |
| 📂 Comm. ➡️ email      | 📄                       | communication de type email                                                  |
| 📂 Comm. ➡️ server     | 📄                       | communication de type serveur                                                |
| 📂 Comm. ➡️ Joplin     | 📄 joplin_json_utils.nim | communication de type Joplin                                                 |
| 📂 Comm. ➡️ Joplin     | 📄 joplin_utils.nim      | communication de type Joplin                                                 |
| 📂 db                 | 📄 database_utils.nim    | Fonctions de type base de données                                            |
| 📂 listes             | 📄                       | Fonctions de traitement de listes                                            |
| 📂 windows ➡️ registry | 📄                       | (Windows) Fonctions de traitement sur clé de registre                        |
| 📂 windows ➡️ wmi      | 📄                       | (Windows) Fonctions de traitement sur WMI                                    |
| 📂 web                | 📄 web_utils.nim         | Fonctions de type web                                                        |


<p align="right">(<a href="#readme-top">back to top</a>)</p>

### Built With

Ces fonctions sont fait pour des projets développés en Nim. Voici la liste des modules a importer par script.

| Section              | script                  | modules                          |
| -------------------- | ----------------------- | -------------------------------- |
| 📂 base               | 📄 OutilsBase.nim        |                                  |
| 📂 commun             | 📄 OutilsCommun.nim      |                                  |
| 📂 commun             | 📄 password_utils.nim    | md5, bcrypt, random              |
| 📂 commun             | 📄 utils.nim             | std/times                        |
| 📂 commun ➡️ load      |                         |                                  |
| 📂 commun ➡️ save      |                         |                                  |
| 📂 Communication      |                         |                                  |
| 📂 Comm. ➡️ discord    |                         |                                  |
| 📂 Comm. ➡️ email      |                         |                                  |
| 📂 Comm. ➡️ server     |                         |                                  |
| 📂 Comm. ➡️ Joplin     | 📄 joplin_json_utils.nim |                                  |
| 📂 Comm. ➡️ Joplin     | 📄 joplin_utils.nim      |                                  |
| 📂 db                 | 📄 database_utils.nim    | os, logging, parsecfg, db_sqlite |
| 📂 listes             | 📄 listes_utils.nim      |                                  |
| 📂 windows ➡️ registry | 📄 registry_utils.nim    |                                  |
| 📂 windows ➡️ wmi      | 📄 wmi_utils.nim         |                                  |
| 📂 web                | 📄 web_utils.nim         |                                  |


[![Nim][Nim.com]][Nim-url]

<p align="right">(<a href="#readme-top">back to top</a>)</p>



<!-- GETTING STARTED -->
## Getting Started

This is an example of how you may give instructions on setting up your project locally.
To get a local copy up and running follow these simple example steps.

### Prerequisites

This is an example of how to list things you need to use the software and how to install them.
* npm
  ```sh
  npm install npm@latest -g
  ```

### Installation

_Below is an example of how you can instruct your audience on installing and setting up your app. This template doesn't rely on any external dependencies or services._

1. Get a free API Key at [https://example.com](https://example.com)
2. Clone the repo
   ```sh
   git clone https://github.com/your_username_/Project-Name.git
   ```
3. Install NPM packages
   ```sh
   npm install
   ```
4. Enter your API in `config.js`
   ```js
   const API_KEY = 'ENTER YOUR API';
   ```

<p align="right">(<a href="#readme-top">back to top</a>)</p>



<!-- USAGE EXAMPLES -->
## Usage

Use this space to show useful examples of how a project can be used. Additional screenshots, code examples and demos work well in this space. You may also link to more resources.

_For more examples, please refer to the [Documentation](https://example.com)_

<p align="right">(<a href="#readme-top">back to top</a>)</p>

<!-- SECTION BASE -->
## Base

Détails, spécifications spécial sur la section Base

<p align="right">(<a href="#readme-top">back to top</a>)</p>


<!-- ROADMAP -->
## Roadmap

- [x] Add Changelog
- [x] Add back to top links
- [ ] Add Additional Templates w/ Examples
- [ ] Add "components" document to easily copy & paste sections of the readme
- [ ] Multi-language Support
    - [ ] Chinese
    - [ ] Spanish

See the [open issues](https://github.com/othneildrew/Best-README-Template/issues) for a full list of proposed features (and known issues).

<p align="right">(<a href="#readme-top">back to top</a>)</p>



<!-- CONTRIBUTING -->
## Contributing

Contributions are what make the open source community such an amazing place to learn, inspire, and create. Any contributions you make are **greatly appreciated**.

If you have a suggestion that would make this better, please fork the repo and create a pull request. You can also simply open an issue with the tag "enhancement".
Don't forget to give the project a star! Thanks again!

1. Fork the Project
2. Create your Feature Branch (`git checkout -b feature/AmazingFeature`)
3. Commit your Changes (`git commit -m 'Add some AmazingFeature'`)
4. Push to the Branch (`git push origin feature/AmazingFeature`)
5. Open a Pull Request

<p align="right">(<a href="#readme-top">back to top</a>)</p>



<!-- LICENSE -->
## License

Distributed under the GNU Public License. See `LICENSE.txt` for more information.

<p align="right">(<a href="#readme-top">back to top</a>)</p>



<!-- CONTACT -->
## Contact

Your Name - [@your_twitter](https://twitter.com/your_username) - email@example.com

Project Link: [https://github.com/your_username/repo_name](https://github.com/your_username/repo_name)

<p align="right">(<a href="#readme-top">back to top</a>)</p>



<!-- ACKNOWLEDGMENTS -->
## Acknowledgments

Use this space to list resources you find helpful and would like to give credit to. I've included a few of my favorites to kick things off!

* [Choose an Open Source License](https://choosealicense.com)
* [GitHub Emoji Cheat Sheet](https://www.webpagefx.com/tools/emoji-cheat-sheet)
* [Malven's Flexbox Cheatsheet](https://flexbox.malven.co/)
* [Malven's Grid Cheatsheet](https://grid.malven.co/)
* [Img Shields](https://shields.io)
* [GitHub Pages](https://pages.github.com)
* [Font Awesome](https://fontawesome.com)
* [React Icons](https://react-icons.github.io/react-icons/search)

<p align="right">(<a href="#readme-top">back to top</a>)</p>



<!-- MARKDOWN LINKS & IMAGES -->
<!-- https://www.markdownguide.org/basic-syntax/#reference-style-links -->
[contributors-shield]: https://img.shields.io/github/contributors/othneildrew/Best-README-Template.svg?style=for-the-badge
[contributors-url]: https://github.com/othneildrew/Best-README-Template/graphs/contributors
[forks-shield]: https://img.shields.io/github/forks/othneildrew/Best-README-Template.svg?style=for-the-badge
[forks-url]: https://github.com/othneildrew/Best-README-Template/network/members
[stars-shield]: https://img.shields.io/github/stars/othneildrew/Best-README-Template.svg?style=for-the-badge
[stars-url]: https://git.bcmaison.cf/Projets/nim-lib/stars
[issues-shield]: https://img.shields.io/github/issues/othneildrew/Best-README-Template.svg?style=for-the-badge
[issues-url]: https://github.com/othneildrew/Best-README-Template/issues
[license-shield]: https://img.shields.io/badge/LICENSE-GNU-green?style=for-the-badge
[license-url]: https://git.bcmaison.cf/Projets/nim-lib/src/branch/main/LICENSE.txt
[linkedin-shield]: https://img.shields.io/badge/-LinkedIn-black.svg?style=for-the-badge&logo=linkedin&colorB=555
[linkedin-url]: https://www.linkedin.com/in/bruno-charest-a3a6158/
[product-screenshot]: images/screenshot.png
[Next.js]: https://img.shields.io/badge/next.js-000000?style=for-the-badge&logo=nextdotjs&logoColor=white
[Next-url]: https://nextjs.org/
[React.js]: https://img.shields.io/badge/React-20232A?style=for-the-badge&logo=react&logoColor=61DAFB
[React-url]: https://reactjs.org/
[Vue.js]: https://img.shields.io/badge/Vue.js-35495E?style=for-the-badge&logo=vuedotjs&logoColor=4FC08D
[Vue-url]: https://vuejs.org/
[Angular.io]: https://img.shields.io/badge/Angular-DD0031?style=for-the-badge&logo=angular&logoColor=white
[Angular-url]: https://angular.io/
[Svelte.dev]: https://img.shields.io/badge/Svelte-4A4A55?style=for-the-badge&logo=svelte&logoColor=FF3E00
[Svelte-url]: https://svelte.dev/
[Laravel.com]: https://img.shields.io/badge/Laravel-FF2D20?style=for-the-badge&logo=laravel&logoColor=white
[Laravel-url]: https://laravel.com
[Bootstrap.com]: https://img.shields.io/badge/Bootstrap-563D7C?style=for-the-badge&logo=bootstrap&logoColor=white
[Bootstrap-url]: https://getbootstrap.com
[JQuery.com]: https://img.shields.io/badge/jQuery-0769AD?style=for-the-badge&logo=jquery&logoColor=white
[JQuery-url]: https://jquery.com 
[Nim.com]: https://img.shields.io/badge/Nim-000000?style=for-the-badge&logo=Nim&logoColor=Yellow
[Nim-url]: https://nim-lang.org/ 

https://img.shields.io/git.bcmaison.cf/forks/othneildrew/Best-README-Template.svg?style=for-the-badge